//---------------------------------------------------------------------------
#include <vcl.h>
#include <NukeDX.h>
#pragma hdrstop

#include "Unit1.h"
#include "Game.h"
#include "Objects.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

// ***    ***
// 
extern NDX_Screen  *NdxScreen;  //   
extern NDX_Surface *gameArt; //   
// 
extern NDX_Sound   *NdxSound;  //    NDX_Sound
extern NDX_Sample  *sampleWalk;
extern NDX_Sample  *sampleMy;
extern NDX_Sample  *sampleDie;
extern NDX_Sample  *sampleOver;
extern NDX_Sample  *sampleFall;
extern NDX_Sample  *sampleComp; // sound "Level Complete"
// 
extern NDX_Timer   *NdxTimer;
extern NDX_Input   *NdxInput;  //   NDX_Input


// ,     
Game_Control *GameControl=NULL;

int Level;  //  
int Lives;  //   
int Score;  //   

double GameOverDelay;       //   .  GAMEOVER
double ShowLevelDelay;      //    
double PlayerDelay;         //   ,      

extern BOOL bTesting;   //    (   Level Editor)
extern int Prog_State;

extern BOOL Menu_Init();
extern BOOL TheEnd_Init();


BOOL Game_Init()
{
    if( GameControl ) delete GameControl;
    GameControl = new Game_Control;
    GameControl -> GameInit();

    //   
    GameOverDelay=0;
    ShowLevelDelay=0;
    PlayerDelay=0;

//   
    Level=1;
    Lives=3;
    Score=0;

    GameControl -> InitLevel(1);
    ShowLevelDelay=1;
    Prog_State=PS_GAME;

    return true;
}

void Game_Update(double td)
{
    if( GameOverDelay )
    {
        GameOverDelay-=td;
        if( GameOverDelay < 0 )
            Menu_Init();
        return;
    }

    if( ShowLevelDelay )
    {
        ShowLevelDelay-=td;
        if( ShowLevelDelay < 0 ) ShowLevelDelay=0;
        return;
    }

    if( PlayerDelay )   //      
    {
        PlayerDelay-=td;
        GameControl->MoveAll(td);
        if( PlayerDelay < 0 )
        {
            PlayerDelay=0;
            if( Lives < 0 ) {
                GameOverDelay=3.5;
                sampleOver->Play(0,0);
                return;
            }
            ShowLevelDelay=1;
            if( Level < 20 )
                GameControl->InitLevel(Level);
            else
                TheEnd_Init();
        }
        return;
    }

    GameControl->MoveAll(td);
    GameControl->Analize();
}


void Game_Draw()
{
    GameControl->DrawAll();
    GameControl->DrawGameBar();

    if( GameOverDelay )
    {
        NdxScreen->Back->FormattedText(100,100,RGB(255,255,255),NULL,"G A M E  O V E R");
    }

    if( ShowLevelDelay )
    {
        NdxScreen->Back->FormattedText(100,100,RGB(255,255,255),NULL,"LEVEL %d", Level);
    }
}







/*
      Game_Control

*/
void Game_Control::GameInit()
{
//  
    GameBarSurf.Create(NdxScreen,NDXST_SYSMEM,236,16);
}
//---------------------------------------------------------------------------
void Game_Control::InitLevel(int num)
{
   char buf[200];
   BOOL bPlayerLoaded=false;
   int type;
   Game_Object *p;

   GO_Level *lev;

    //    
    RemoveAll();

    need_keys=0;

    //    
    if( !bTesting )  {
        sprintf(buf,"level%d.lev",num);
        lev =  new GO_Level(buf);
    }
    else  {
        lev =  new GO_Level( ParamStr(1).c_str() );
    }


    AddSprite(lev);  //     

    //    
     for(int n=0; n<lev->Level.KolObj; n++)
    {
		p=NULL;
		type=lev->Level.Obj[n].type;
        switch(type)	//   
        {
        case GO_ENEMY1:
            p=new GO_Enemy1();
            break;
        case GO_KEY:
            p=new GO_Key();
            need_keys++;
            break;
        case GO_PLAYER:
            if(bPlayerLoaded)continue;
            p=new GO_Player();
            bPlayerLoaded=true;
            break;
        };
		if(p)	//  
		{
			p->Create( &lev->Level.Obj[n] ); // 
	        AddSprite(p);		//    
		}
    }

//     
	 if( !bPlayerLoaded )
        {
            MessageBox( Application->Handle, "Object Player not found in this level", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }

//     
	 if( !need_keys )
        {
            MessageBox( Application->Handle, "Not found keys in this level, abort.", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }

//      
    keys=0;  //   

    RefreshGameBar();  //    
}
//---------------------------------------------------------------------------
void Game_Control::PlayerKilled()
{
    Lives--;
    PlayerDelay=2.5;
}
//-----------------------------------------------------------------------------
void Game_Control::NextLevel()
{
    ++Level;
    PlayerDelay=1;
    sampleComp->Play(0,0);
}
//-----------------------------------------------------------------------------
void Game_Control::Analize()
{
    //    (   ..)
	for(int n=0;n<NumSprites;n++)
	{
		((Game_Object*)Sprites[n])->CheckForHits(this);
	}
}
//-----------------------------------------------------------------------------
void Game_Control::RefreshGameBar()
{
    //      
    GameBarSurf.Clear(0);
    GameBarSurf.FormattedText(0,0,RGB(255,255,255),NULL,"score:%d   level:%d  lives:%d  keys:%d/%d",Score,Level,Lives,keys,need_keys);
}
//-----------------------------------------------------------------------------
void Game_Control::DrawGameBar()
{
    //  
    GameBarSurf.Draw(NdxScreen->Back,80,0);
}
//---------------------------------------------------------------------------
void Game_Control::RemoveAll()
{
NDX_Sprite *p;

    while( NumSprites )
    {
        p=Sprites[0];
        GameControl->RemoveSprite(p);  //   
        delete p;  //  
    }
}
//-----------------------------------------------------------------------------

