//---------------------------------------------------------------------------
#include <vcl.h>
#include <NukeDX.h>
#pragma hdrstop

#include "Menu.h"
#include "Unit1.h"
#include "Unit2.h"
#include "Game.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#define MENU_OPTION_MAX 3


// ***    ***
// 
extern NDX_Screen  *NdxScreen;
extern NDX_Surface *menuArt;
// 
extern NDX_Sound   *NdxSound;
// 
extern NDX_Timer   *NdxTimer;
extern NDX_Input   *NdxInput;

extern int Prog_State;
extern BOOL bRunApp;


//     - 
Menu_Option *options[MENU_OPTION_MAX];

extern int m_x,m_y;    //  
int m_b;  //   
int n;  //   

void Draw_Cursor();
BOOL isPoint_in_RECT(int x, int y,RECT area);

//   
void action_start();
void action_exit();
void action_about();


//  ***   ***

BOOL Menu_Init()
{
    //  

    for( n=0; n<MENU_OPTION_MAX; n++)
        if( options[n] ) delete options[n];

    options[0]= new Menu_Option;
    options[1]= new Menu_Option;
    options[2]= new Menu_Option;

    options[0] -> Create( Rect(120,100,120+76,100+28), Rect(0,5,76+0,28+5),action_start);
    options[1] -> Create( Rect(120,140,120+74,140+28),Rect(0,41,74+0,28+41),action_exit);
    options[2] -> Create( Rect(120,180,120+76,180+27),Rect(0,74,76+0,27+74),action_about);

//    NdxInput->SetMouseLimit(NdxScreen);
//    NdxInput->SetMouseAbs();
//    NdxInput->SetMousePos(100,100);
//    m_x=NdxInput->MouseXPos;
//    m_y=NdxInput->MouseYPos;
    m_b=0;

    Prog_State = PS_MENU;
    return true;
}

BOOL Menu_Update(double td)
{
/*   DirectInput    , 
       Windows.  
       ,     .
     - ,   , , 

    m_x = NdxInput -> MouseXPos;
    m_y = NdxInput -> MouseYPos;

*/
    m_b = NdxInput -> MouseLB;
    for( n=0; n<MENU_OPTION_MAX; n++)
        if(options[n]) options[n] -> Update();

    return true;
}


void Menu_Draw()
{
    for( n=0; n<MENU_OPTION_MAX; n++)
        if(options[n]) options[n] -> Draw();

    Draw_Cursor();
}


void Draw_Cursor()
{
    //      
    RECT area=(!m_b)? Rect(0,120,7,15+120) : Rect(8,120,8+8,15+120);
    menuArt -> Draw(NdxScreen->Back,m_x,m_y,area);
}



//  ***     ***

void Menu_Option::Create(RECT _area, RECT _src, void(*_action)() )
{
    //      
    memcpy(&area,&_area,sizeof(RECT));
    memcpy(&src,&_src,sizeof(RECT));
    action=_action;

    bSelected=false;
}

void Menu_Option::Update()
{
    if( bSelected)
    {
        if( !isPoint_in_RECT(m_x,m_y,area) )
            bSelected=false;
    }
    else
    {
        if( isPoint_in_RECT(m_x,m_y,area) )
        {
            bSelected=true;
//            sampleSelect->Play(0,0);
        }
    }

    //     ,  
    if( bSelected && NdxInput->MouseLBClick )
    {
        NdxInput->MouseLBClick=false;
        action();
    }
}

void Menu_Option::Draw()
{
    menuArt->Draw(NdxScreen->Back,src,area);

    //      ,   -  (    )
    if( bSelected ) ;
//    menuArt->Draw(NdxScreen->Back,area.left, area.top,Rect(0,75,80,30+75));
//    menuArt->DrawAlpha(NdxScreen->Back,area.left,area.top,Rect(1,75,80+1,75+30));
}


BOOL isPoint_in_RECT(int x, int y,RECT area)
{
    //    ,  true
    if( x<area.left) return false;
    if( x>area.right) return false;
    if( y<area.top) return false;
    if( y>area.bottom) return false;
    return true;
}

void action_start()
{
    Game_Init();
}

void action_exit()
{
    bRunApp=false;
}

void action_about()
{
    Form2->ShowModal();
}

