//---------------------------------------------------------------------------

#include <vcl.h>

#include <NukeDX.h>
#pragma hdrstop

#include "Objects.h"
#include "Unit1.h"

extern NDX_Surface gfxArt;
extern NDX_Screen *NdxScreen;
extern NDX_Input *NdxInput;
extern Game_Control GameControl;

extern NDX_Sample *SampleWalk;
extern NDX_Sample *SampleMy;
extern NDX_Sample *SampleDie;
extern NDX_Sample *SampleGameOver;
extern NDX_Sample *SampleFall;

extern BOOL bTesting;
extern int Program_State;



//   
void OutMessage(String s)
{
static int n=0;
Form1->MessageMemo->Lines->Add(IntToStr(n)+"  "+s);
n++;
}
BOOL HitRect(const RECT *Rect1,const RECT *Rect2)
{
	if(Rect1->top >= Rect2->bottom) return FALSE;
	else if(Rect1->bottom <= Rect2->top) return FALSE;
	else if(Rect1->right <= Rect2->left) return FALSE;
	else if(Rect1->left >= Rect2->right) return FALSE;

	return TRUE;
}



//  Game_Control
void Game_Control::PlayerKilled()
{
    Lives--;
    if( Lives < 0 )
        GameOver();

    InitLevel(Level);
    showDelay=1500;
}

void Game_Control::GameOver()
{
    bGameOver=1;
}

//    (   ..)
void Game_Control::Analize()
{
	for(int n=0;n<NumSprites;n++)
	{
		((Game_Object*)Sprites[n])->CheckForHits(this);
	}
}

void Game_Control::RefreshGameBar()
{
    //      
    GameBarSurf.Clear(0);
    GameBarSurf.FormattedText(0,0,RGB(255,255,255),NULL,"score:%d   level:%d  lives:%d  keys:%d/%d",Score,Level,Lives,keys,need_keys);
}
void Game_Control::DrawGameBar()
{
    //  
    GameBarSurf.Draw(NdxScreen->Back,80,0);
}


//---------------------------------------------------------------------------
void Game_Control::GameInit()
{
//  
    GameBarSurf.Create(NdxScreen,NDXST_SYSMEM,236,16);

//   
    Level=1;
    Lives=3;
    Score=0;

    InitLevel(1);
}
//---------------------------------------------------------------------------
void Game_Control::InitLevel(int num)
{
   char buf[200];
   BOOL bPlayerLoaded=false;
   int type;
   Game_Object *p;

   GO_Level *lev;

    //    
    GameControl.RemoveAll();

    need_keys=0;

    //    
    if( !bTesting )  {
        sprintf(buf,"level%d.lev",num);
        lev =  new GO_Level(buf);
    }
    else  {
        lev =  new GO_Level( ParamStr(1).c_str() );
    }


    GameControl.AddSprite(lev);  //     

    //    
     for(int n=0; n<lev->Level.KolObj; n++)
    {
		p=NULL;
		type=lev->Level.Obj[n].type;
        switch(type)	//   
        {
        case GO_ENEMY1:
            p=new GO_Enemy1();
            break;
        case GO_KEY:
            p=new GO_Key();
            need_keys++;
            break;
        case GO_PLAYER:
            if(bPlayerLoaded)continue;
            p=new GO_Player();
            bPlayerLoaded=true;
            break;
        };
		if(p)	//  
		{
			p->Create( &lev->Level.Obj[n] ); // 
	        GameControl.AddSprite(p);		//    
		}
    }

//     
	 if( !bPlayerLoaded )
        {
            MessageBox( Application->Handle, "Object Player not found in this level", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }

//     
	 if( !need_keys )
        {
            MessageBox( Application->Handle, "Not found keys in this level, abort.", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }

//      
    keys=0;  //   

    RefreshGameBar();  //    

    Program_State=PS_ACTIVE;
}
//---------------------------------------------------------------------------
void Game_Control::RemoveAll()
{
NDX_Sprite *p;

    while( NumSprites )
    {
        p=Sprites[0];
        GameControl.RemoveSprite(p);  //   
        delete p;  //  
    }
}

void Game_Control::NextLevel()
{
    showDelay=1000;
    ++Level;
    if( Level < 20 )
        InitLevel(Level);
    else
//        GameWin();
    Form1->Close();

}


//   

Game_Object::Game_Object()
{
    //  
    x=y=0;
    len=hgt=16;  //   
    frame=type=0;
    div_x=div_y=0;
    action=SA_STILL;
}

void Game_Object::Draw()
{
    Frames.Draw(NdxScreen->Back,x ,y, frame );
}

BOOL Game_Object::HitObject( Game_Object* obj1)
{
    Game_Object *obj2=this;

	RECT Rect1 = { obj1->x, obj1->y,
								 obj1->x+obj1->len,
								 obj1->y+obj1->hgt };
	RECT Rect2 = { obj2->x, obj2->y,
								 obj2->x+obj2->len,
								 obj2->y+obj2->hgt };

	return HitRect(&Rect1, &Rect2);
}





/*==========================================================

        ***   LEVEL    ***
*/

__fastcall GO_Level::GO_Level(char *name)
{
    type=GO_LEVEL;
    if( Level.Load(name) != true )
        MessageBox( Application->Handle, "Erorr load level.", "Level", MB_OK );

}

void GO_Level::Draw()
{
    static RECT area=Rect(0,0,320,240);
    //    
    Level.Draw(NdxScreen->Back,x,y,area);
}

// ,      
// (    )
int GO_Level::isPassingTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==(-1) ) return false;  //     - 
    return true;  //  - 
}

//  true,      
int GO_Level::isGroundTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==2 || i==(-1)) return true;  //    - 
    return false;
}


void GO_Level::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,    -    
    //       
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_PLAYER:
            case GO_ENEMY1:
            if( o->action==SA_FALL )  {
            // GM_INTOGROUND_X  , 
            //     ,    ,
            //    .
                if(
                  //     
                  //    
                  ( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)
                  )
                     //     
                     // ,  GM_INTOGROUND_X
                  &&( isPassingTile(o->prev_x+2,o->y+2)  &&
                      isPassingTile(o->prev_x+o->len-2,o->y+2) &&
                      isPassingTile(o->prev_x+2,o->y+o->hgt-1) &&
                      isPassingTile(o->prev_x+o->len-2,o->y+o->hgt-1)
                  )
                     ) {
                    Game_Message msg={GM_INTOGROUND_X,0,0};
                    o->Message(&msg);
                }
                if( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
            } else {
                if( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
            }
                if( !( o->action==SA_FALL) ) {  //   ,  ,    
                    if( !isGroundTile(o->x+2,o->y+o->hgt) && !isGroundTile(o->x+o->len-2, o->y+o->hgt) ) {
                        Game_Message msg={GM_NOGROUND,0,0};
                        o->Message(&msg);
                    }
                    //   , ,   
                } else if( isGroundTile(o->x+2,o->y+o->hgt) || isGroundTile(o->x+o->len-2, o->y+o->hgt) ) {
                        Game_Message msg={GM_GROUND,0,0};
                        o->Message(&msg);
                    }

                break;
//            case :
//                break;
//            default:
        }
	}
}



void Game_Object::Create(LEVFILEOBJECT *levobj)
{
    x=levobj->posx;
    y=levobj->posy;
}


/*==========================================================

        ***   PLAYER    ***
*/
GO_Player::GO_Player()
{
    bCanClimbUp=false;
    bCanClimbDown=false;
    type=GO_PLAYER;
    len=11; hgt=15;
    Frames.AddFrames( &gfxArt, 0,48,  16,16,  3,2 );
}


//    Move    .
//     -   
//  ,   ..    Message
//     .
void GO_Player::Move(double td)
{
static frame1,frame2;  //    
static float fd=0;     //      

        //  
        if( NdxInput->Keys[DIK_LEFT] && !NdxInput->Keys[DIK_RIGHT])  {
            div_x=(action==SA_FALL)? -10:-70;
            if( action==SA_CLIMB ) div_y=0;
            frame1=4;
            frame2=5;
            if( !SampleWalk->IsPlaying(snd_Walk_h) && action!=SA_FALL)
                SampleWalk->Play(0,&snd_Walk_h);
        } else
        //  
        if( NdxInput->Keys[DIK_RIGHT] && !NdxInput->Keys[DIK_LEFT])  {
            div_x=(action==SA_FALL)? 10: 70;
            if( action==SA_CLIMB ) div_y=0;
            frame1=1;
            frame2=2;
            if( !SampleWalk->IsPlaying(snd_Walk_h) && action!=SA_FALL )
                SampleWalk->Play(0,&snd_Walk_h);
        }
        else if( !NdxInput->Keys[DIK_UP]&& !NdxInput->Keys[DIK_DOWN] ){
        //       
            if(action!=SA_FALL) {
                frame1=0;
                frame2=0;
                div_x=div_y=0;
                if( SampleWalk->IsPlaying(snd_Walk_h)  )
                    SampleWalk->Stop(snd_Walk_h);
            } else div_x=0;
        }
//    } //  if( action!=SA_FALL)



    //        
    if( NdxInput->Keys[DIK_UP])  {
        if( bCanClimbUp )  {
            if(action!=SA_CLIMB) {
                div_x=0;
                //   
                if( SampleWalk->IsPlaying(snd_Walk_h) )
                    SampleWalk->Stop(snd_Walk_h);
            }
            action=SA_CLIMB; //      ,   
            div_y=-40;
            frame1=1;
            frame2=3;
        } else {
            if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
        }
    } else

    //       ,   
    if( NdxInput->Keys[DIK_DOWN] )  {
        if( bCanClimbDown )  {
            if(action!=SA_CLIMB) {
                div_x=0;
                //   
                if( SampleWalk->IsPlaying(snd_Walk_h) )
                    SampleWalk->Stop(snd_Walk_h);
            }
            action=SA_CLIMB; //      ,   
            div_y=40;
            frame1=1;
            frame2=3;
        } else if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
    }


//   
    if( frame == frame1 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame2;
            fd=0;
        }
    } else
    if( frame == frame2 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame1;
            fd=0;
        }
    } else {
        frame=frame1;
        fd=0;
    }




    //  
    if( action==SA_FALL) {
            frame=3;
    }

    prev_x = x;
    prev_y = y;

    x = x + div_x*td;
    y = y + div_y*td;

if( NdxInput->Keys[DIK_K])
OutMessage("Player x="+FloatToStr(x)+" y="+FloatToStr(y));



}

void GO_Player::Message(void *m)
{
    Game_Message *msg=(Game_Message *)m;
    switch (msg->type)
    {
      case GM_INTOGROUND_X:  //        
        OutMessage("Player Message: GM_INTOGROUND_X");
        x=prev_x;
      break;
      case GM_INTOGROUND:  //     
        OutMessage("Player Message: GM_INTOGROUND");
        x=prev_x;
        y=prev_y;
        frame=0;
        action=SA_STILL;
      break;

      case GM_NOGROUND:  //  
        OutMessage("Player Message: GM_NOGROUND");
        action=SA_FALL;
        div_x=0;
        div_y=70;
        //   
        if( SampleWalk->IsPlaying(snd_Walk_h) )
            SampleWalk->Stop(snd_Walk_h);
        //   
        SampleFall->Play(0,&snd_Fall_h);
      break;

      case GM_GROUND:  //  
        OutMessage("Player Message: GM_GROUND");
        action=SA_STILL;
        div_x=0;
        div_y=0;
        frame=0;
        //   
        if( SampleFall->IsPlaying(snd_Fall_h) )
            SampleFall->Stop(snd_Fall_h);
      break;
    }
}

void GO_Player::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,       
    //          
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_LEVEL:
                //    
                if( ((GO_Level*)o)->Level.GetTile(x+2,y+hgt-1) ==2 &&
                      ((GO_Level*)o)->Level.GetTile(x+12,y+hgt-1) ==2 )  {
                //     ,  
                    bCanClimbUp=true;
                } else bCanClimbUp=false;
                //     
                if(   ((GO_Level*)o)->Level.GetTile(x+2,y+hgt) ==2  &&
                      ((GO_Level*)o)->Level.GetTile(x+12,y+hgt) ==2  ) {
                //    (   )  ,  
                    bCanClimbDown=true;
                } else bCanClimbDown=false;

                break;
            case GO_ENEMY1:
                if( HitObject(o) ) {
                    GameControl.PlayerKilled();
                    SampleDie->Play(0,0);
                    return;
                }
            case GO_KEY:
                if( HitObject(o) ) {
                    GameControl.RemoveSprite(o);
                    delete o;
                    GameControl.keys++;
                    GameControl.RefreshGameBar();
                    if( GameControl.keys == GameControl.need_keys )
                        GameControl.NextLevel();
                    else
                        SampleMy->Play(0,0);
                }

//            case :
//                break;
            default: ;
        }
	}
}







/*==========================================================

        ***   ENEMY1    ***
*/
GO_Enemy1::GO_Enemy1()
{
    type=GO_ENEMY1;
    move_count=0;
    len=12; hgt=14;
    Frames.AddFrames( &gfxArt,0,81,len,hgt,4,1);
}

void GO_Enemy1::Move(double td)
{
    if(div_x == 0 ) div_x=14;

    //   frame
    frame+=td*14;
    if( div_x > 0 ) {
        if( frame > 2) frame=0;
    }
    else {
        if( frame > 4) frame=2;
    }

    // 
    prev_x=x;
    x+=div_x*td;


}

void GO_Enemy1::Message(void *m)
{
/*
    Game_Message *msg=(Game_Message *)m;
    switch (msg->type)
    {
      case GM_INTOGROUND_X:  //        
        OutMessage("Enemy Message: GM_INTOGROUND_X");
      break;
      case GM_INTOGROUND:  //     
        OutMessage("Enemy Message: GM_INTOGROUND");
      break;

      case GM_NOGROUND:  //  
        OutMessage("Enemy Message: GM_NOGROUND");
      break;

      case GM_GROUND:  //  
        OutMessage("Enemy Message: GM_GROUND");
      break;
    }
*/

    x=prev_x;
    div_x *= (-1);

}


// 
GO_Key::GO_Key()
{
    type=GO_KEY;
    len=5; hgt=8;
    Frames.AddFrames( &gfxArt, 3,100,len,hgt,1,1 );
    frame=0;
}


//---------------------------------------------------------------------------

#pragma package(smart_init)
