//---------------------------------------------------------------------------
#include <vcl.h>
#include <NukeDX.h>
#pragma hdrstop

//---------------------------------------------------------------------------
#pragma package(smart_init)

#include "Unit1.h"
#include "Objects.h"
#include "Game.h"

// ***    ***
extern NDX_Screen  *NdxScreen;
extern NDX_Surface *gameArt;
extern NDX_Input   *NdxInput;
extern Game_Control *GameControl;

extern NDX_Sample *sampleWalk;
extern NDX_Sample *sampleMy;
extern NDX_Sample *sampleDie;
extern NDX_Sample *sampleGameOver;
extern NDX_Sample *sampleFall;

extern BOOL bTesting;
extern int Program_State;

extern double PlayerDelay;

//   
void OutMessage(String s)
{
//   
static int n=0;
Form1->MessageMemo->Lines->Add(IntToStr(n)+"  "+s);
n++;
}
BOOL HitRect(const RECT *Rect1,const RECT *Rect2)
{
	if(Rect1->top >= Rect2->bottom) return FALSE;
	else if(Rect1->bottom <= Rect2->top) return FALSE;
	else if(Rect1->right <= Rect2->left) return FALSE;
	else if(Rect1->left >= Rect2->right) return FALSE;

	return TRUE;
}




//  ***    ***

//  
Game_Object::Game_Object()
{
    //  
    x=y=0;
    frame=0;
    div_x=div_y=0;

    len=hgt=16;  //   
    action=SA_STILL;
}

//   
void Game_Object::Create(LEVFILEOBJECT *levobj)
{
    //      
    x=levobj->posx;
    y=levobj->posy;
    param=levobj->param;  //      
}


void Game_Object::Draw()
{
    // -1  ,     (  )
    if( frame != -1 )
    {
        //   frame  framelist'
        Frames.Draw(NdxScreen->Back,x ,y, frame );
    }
}

//  true   
BOOL Game_Object::HitObject( Game_Object* obj1)
{
    Game_Object *obj2=this;

	RECT Rect1 = { obj1->x, obj1->y,
								 obj1->x+obj1->len,
								 obj1->y+obj1->hgt };
	RECT Rect2 = { obj2->x, obj2->y,
								 obj2->x+obj2->len,
								 obj2->y+obj2->hgt };

	return HitRect(&Rect1, &Rect2);
}





/*==========================================================

        ***   LEVEL    ***
*/

//   Level,      GameObject
__fastcall GO_Level::GO_Level(char *name)
{
    if( Level.Load(name) != true )
        MessageBox( Application->Handle, "Erorr load level.", "Level", MB_OK );
        type=GO_LEVEL;
}

void GO_Level::Draw()
{
    static RECT area=Rect(0,0,320,240);
    //    
    Level.Draw(NdxScreen->Back,x,y,area);
}

// ,      
// (    )
int GO_Level::isPassingTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==(-1) ) return false;  //     - 
    return true;  //  - 
}

//  true,      
int GO_Level::isGroundTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==2 || i==(-1)) return true;  //    - 
    return false;
}

//       
// (,    -   
//    )
void GO_Level::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,    -    
    //       
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_ENEMY1:

            /*  ,    case GO_PLAYER   
                     
             (  ).  ,  
             ,  ,  ,    case
            */
            case GO_PLAYER:
            if( o->action==SA_FALL )  {
            // GM_INTOGROUND_X  , 
            //     ,    ,
            //    .
                if(
                  //     
                  //    
                  ( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)
                  )
                     //     
                     // ,  GM_INTOGROUND_X
                  &&( isPassingTile(o->prev_x+2,o->y+2)  &&
                      isPassingTile(o->prev_x+o->len-2,o->y+2) &&
                      isPassingTile(o->prev_x+2,o->y+o->hgt-1) &&
                      isPassingTile(o->prev_x+o->len-2,o->y+o->hgt-1)
                  )
                     ) {
                    Game_Message msg={GM_INTOGROUND_X,0,0};
                    o->Message(&msg);
                }
                if( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
            } else {
                if( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+o->len-2,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+o->hgt-1) ||
                    !isPassingTile(o->x+o->len-2,o->y+o->hgt-1)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
            }
                if( !( o->action==SA_FALL) ) {  //   ,  ,    
                    if( !isGroundTile(o->x+2,o->y+o->hgt) && !isGroundTile(o->x+o->len-2, o->y+o->hgt) ) {
                        Game_Message msg={GM_NOGROUND,0,0};
                        o->Message(&msg);
                    }
                    //   , ,   
                } else if( isGroundTile(o->x+2,o->y+o->hgt) || isGroundTile(o->x+o->len-2, o->y+o->hgt) ) {
                        Game_Message msg={GM_GROUND,0,0};
                        o->Message(&msg);
                    }

                break;
            case GO_KAPLYA:
            //      
                if( !isPassingTile(o->x,o->y+o->hgt) ||
                    !isPassingTile(o->x+o->len,o->y+o->hgt)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
                break;
//            case :
//                break;
//            default:
        }
	}
}




/*==========================================================

        ***   PLAYER    ***
*/
//   
GO_Player::GO_Player()
{
    bCanClimbUp=false;
    bCanClimbDown=false;
    len=11; hgt=15;
    Frames.AddFrames( gameArt, 0,48,  16,16,  3,2 );
    snd_Walk_h=snd_Fall_h=NULL;
}


//    Move    .
//     -   
//  ,   ..    Message
//     .
void GO_Player::Move(double td)
{
static frame1,frame2;  //    
static float fd=0;     //      

    if( PlayerDelay ) return;  //   ,       


        //  
        if( NdxInput->Keys[DIK_LEFT] && !NdxInput->Keys[DIK_RIGHT])  {
            div_x=(action==SA_FALL)? -10:-70;   //     
            if( action==SA_CLIMB ) div_y=0;
            frame1=4;
            frame2=5;
            if( snd_Walk_h ) //    NULL
            if( !sampleWalk->IsPlaying(snd_Walk_h) && action!=SA_FALL)
                sampleWalk->Play(0,&snd_Walk_h);
        }

        //  
        if( NdxInput->Keys[DIK_RIGHT] && !NdxInput->Keys[DIK_LEFT])  {
            div_x=(action==SA_FALL)? 10: 70;
            if( action==SA_CLIMB ) div_y=0;
            frame1=1;
            frame2=2;
            if( snd_Walk_h ) //    NULL
            if( !sampleWalk->IsPlaying(snd_Walk_h) && action!=SA_FALL )
                sampleWalk->Play(0,&snd_Walk_h);
        }

        //       
        if( !NdxInput->Keys[DIK_UP]   && !NdxInput->Keys[DIK_DOWN] &&
            !NdxInput->Keys[DIK_LEFT] && !NdxInput->Keys[DIK_RIGHT]){
            if(action!=SA_FALL) { // , ,  
                frame1=0;
                frame2=0;
                div_x=div_y=0;
                //   
                if( snd_Walk_h ) //    NULL
                if( sampleWalk->IsPlaying(snd_Walk_h)  )
                    sampleWalk->Stop(snd_Walk_h);
            } else div_x=0; //  ,   =0
        }


    //        
    if( NdxInput->Keys[DIK_UP])  {
        div_x=0;
        if( bCanClimbUp )  {
            if(action!=SA_CLIMB) {
                div_x=0;
                //   
                if( snd_Walk_h ) //    NULL
                if( sampleWalk->IsPlaying(snd_Walk_h) )
                    sampleWalk->Stop(snd_Walk_h);
            }
            action=SA_CLIMB; //      ,   
            div_y=-40;
            frame1=1;
            frame2=3;
        } else {
            if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
        }
    }

    //       ,   
    if( NdxInput->Keys[DIK_DOWN] )  {
    div_x=0;
        if( bCanClimbDown )  {
            if(action!=SA_CLIMB) {
                div_x=0;
                //   
                if( snd_Walk_h ) //    NULL
                if( sampleWalk->IsPlaying(snd_Walk_h) )
                    sampleWalk->Stop(snd_Walk_h);
            }
            action=SA_CLIMB; //      ,   
            div_y=40;
            frame1=1;
            frame2=3;
        } else if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
    }


//   
    if( frame == frame1 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame2;
            fd=0;
        }
    } else
    if( frame == frame2 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame1;
            fd=0;
        }
    } else {
        frame=frame1;
        fd=0;
    }

    //  
    if( action==SA_FALL) {
            frame=3;
    }

    prev_x = x;
    prev_y = y;

    x = x + div_x*td;
    y = y + div_y*td;

if( NdxInput->Keys[DIK_K])
OutMessage("Player x="+FloatToStr(x)+" y="+FloatToStr(y));

}

void GO_Player::Message(void *m)
{
    if( PlayerDelay ) return;

    Game_Message *msg=(Game_Message *)m;
    switch (msg->type)
    {
      case GM_INTOGROUND_X:  //        
        OutMessage("Player Message: GM_INTOGROUND_X");
        x=prev_x;
      break;
      case GM_INTOGROUND:  //     
        OutMessage("Player Message: GM_INTOGROUND");
        x=prev_x;
        y=prev_y;
        frame=0;
        action=SA_STILL;
      break;

      case GM_NOGROUND:  //  
        OutMessage("Player Message: GM_NOGROUND");
        action=SA_FALL;
        div_x=0;
        div_y=70;
        //   
        if( snd_Walk_h ) //    NULL
        if( sampleWalk->IsPlaying(snd_Walk_h) )
            sampleWalk->Stop(snd_Walk_h);
        //   
        sampleFall->Play(0,&snd_Fall_h);
      break;

      case GM_GROUND:  //  
        OutMessage("Player Message: GM_GROUND");
        action=SA_STILL;
        div_x=0;
        div_y=0;
        frame=0;
        //   
        if( snd_Fall_h ) //    NULL
        if( sampleFall->IsPlaying(snd_Fall_h) )
            sampleFall->Stop(snd_Fall_h);
      break;
    }
}

void GO_Player::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,       
    //          
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_LEVEL:
                //    
                if( ((GO_Level*)o)->Level.GetTile(x+2,y+hgt-1) ==2 &&
                      ((GO_Level*)o)->Level.GetTile(x+len-2,y+hgt-1) ==2 )  {
                //     ,  
                    bCanClimbUp=true;
                } else bCanClimbUp=false;
                //     
                if(   ((GO_Level*)o)->Level.GetTile(x+2,y+hgt) ==2  &&
                      ((GO_Level*)o)->Level.GetTile(x+len-2,y+hgt) ==2  ) {
                //    (   )  ,  
                    bCanClimbDown=true;
                } else bCanClimbDown=false;

                break;
            case GO_ENEMY1:
            case GO_KAPLYA:
                if( HitObject(o) ) {
                    GameControl->PlayerKilled();
                    sampleDie->Play(0,0);
                    return;
                }
            case GO_KEY:
                if( HitObject(o) ) {
                    Sprites->RemoveSprite(o);
                    delete o;
                    GameControl->keys++;
                    GameControl->RefreshGameBar();
                    if( GameControl->keys == GameControl->need_keys )
                        GameControl->NextLevel();
                    else
                        sampleMy->Play(0,0);
                }

//            case :
//                break;
            default: ;
        }
	}
}







/*==========================================================

        ***   ENEMY1    ***
*/
GO_Enemy1::GO_Enemy1()
{
    move_count=0;
    len=12; hgt=14;
    Frames.AddFrames( gameArt,0,81,len,hgt,4,1);
}

void GO_Enemy1::Move(double td)
{
    if(div_x == 0 ) div_x=14;

    //   frame
    frame+=td*14;
    if( div_x > 0 ) {
        if( frame > 2) frame=0;
    }
    else {
        if( frame > 4) frame=2;
    }

    // 
    prev_x=x;
    x+=div_x*td;


}

void GO_Enemy1::Message(void *m)
{
/*
    Game_Message *msg=(Game_Message *)m;
    switch (msg->type)
    {
      case GM_INTOGROUND_X:  //        
        OutMessage("Enemy Message: GM_INTOGROUND_X");
      break;
      case GM_INTOGROUND:  //     
        OutMessage("Enemy Message: GM_INTOGROUND");
      break;

      case GM_NOGROUND:  //  
        OutMessage("Enemy Message: GM_NOGROUND");
      break;

      case GM_GROUND:  //  
        OutMessage("Enemy Message: GM_GROUND");
      break;
    }
*/

    x=prev_x;
    div_x *= (-1);

}


// 
GO_Key::GO_Key()
{
    len=5; hgt=8;
    Frames.AddFrames( gameArt, 3,100,len,hgt,1,1 );
}

//  
GO_Kaplya_Emiter::GO_Kaplya_Emiter()
{
    len=6; hgt=2;
    Frames.AddFrames( gameArt, 18,100,len,hgt,1,1 );
    delay=delay=1+rand()%40/10.;
}
void GO_Kaplya_Emiter::Move(double td)
{
    //  3 .  
    delay-=td;
    if( delay < 0 )
    {
        delay=1+rand()%40/10.;
        GameControl->AddSprite( new GO_Kaplya(this));
    }
}

//  
GO_Kaplya::GO_Kaplya(GO_Kaplya_Emiter *emiter)
{
    len=4; hgt=5;
    x=emiter->x;
    y=emiter->y;
    Frames.AddFrames( gameArt,31,101,len,hgt,1,1 );
    type=GO_KAPLYA;
}
void GO_Kaplya::Move(double td)
{
    div_y+=td*10;
    y+=div_y;
}
void GO_Kaplya::Message(void *m)
{
    Game_Message *msg=(Game_Message *)m;

    //   ,  
    if( msg->type == GM_INTOGROUND )
    {
        GameControl->RemoveSprite(this);
        delete this;
    }
}


// 
GO_Lift::GO_Lift()
{
    len=17; hgt=3;
    Frames.AddFrames( gameArt,40,102,len,hgt,1,1 );
}

void GO_Lift::Move(double td)
{
    //      
}

GO_Lift_Target::GO_Lift_Target()
{
    frame=-1; //  
}




