//---------------------------------------------------------------------------

#include <vcl.h>

#include <NukeDX.h>
#pragma hdrstop

#include "Objects.h"
#include "Unit1.h"

extern NDX_Surface gfxArt;
extern NDX_Screen *NdxScreen;
extern NDX_Input *NdxInput;


void OutMessage(String s)
{
static int n=0;
Form1->MessageMemo->Lines->Add(IntToStr(n)+"  "+s);
n++;
}





//    (   ..)
void Game_Control::Analize()
{
	for(int n=0;n<NumSprites;n++)
	{
		((Game_Object*)Sprites[n])->CheckForHits(this);
	}
}



//   



Game_Object::Game_Object()
{
    //  
    x=y=0;
    frame=type=0;
    div_x=div_y=action=0;
}






void Game_Object::Draw()
{
    Frames.Draw(NdxScreen->Back,x ,y, frame );
}

/*==========================================================

        ***   LEVEL    ***
*/

__fastcall GO_Level::GO_Level(char *name)
{
    type=GO_LEVEL;
    if( Level.Load(name) != true )
        MessageBox( Application->Handle, "Erorr load level.", "Level", MB_OK );

}

void GO_Level::Draw()
{
    static RECT area=Rect(0,0,320,240);
    //    
    Level.Draw(NdxScreen->Back,x,y,area);
}

// ,      
// (    )
int GO_Level::isPassingTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==(-1) ) return false;  //     - 
    return true;  //  - 
}

//  true,      
int GO_Level::isGroundTile(int pixel_x,int pixel_y)
{
    int i=Level.GetTile(pixel_x,pixel_y);

    if( i==1 || i==2 || i==(-1)) return true;  //    - 
    return false;
}


void GO_Level::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,    -    
    //       
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_PLAYER:
            if( o->action==SA_FALL )  {
            // GM_INTOGROUND_X  , 
            //     ,    ,
            //    .
                if(
                  //     
                  //    
                  ( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+12,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+15) ||
                    !isPassingTile(o->x+12,o->y+15)
                  )
                     //     
                     // ,  GM_INTOGROUND_X
                  &&( isPassingTile(o->prev_x+2,o->y+2)  &&
                      isPassingTile(o->prev_x+12,o->y+2) &&
                      isPassingTile(o->prev_x+2,o->y+15) &&
                      isPassingTile(o->prev_x+12,o->y+15)
                  )
                     ) {
                    Game_Message msg={GM_INTOGROUND_X,0,0};
                    o->Message(&msg);
                }
            } else {
                if( !isPassingTile(o->x+2,o->y+2) ||
                    !isPassingTile(o->x+12,o->y+2) ||
                    !isPassingTile(o->x+2,o->y+15) ||
                    !isPassingTile(o->x+12,o->y+15)  ) {
                    Game_Message msg={GM_INTOGROUND,0,0};
                    o->Message(&msg);
                }
            }
                if( !( o->action==SA_FALL) ) {  //   ,  ,    
                    if( !isGroundTile(o->x+2,o->y+16) && !isGroundTile(o->x+12, o->y+16) ) {
                        Game_Message msg={GM_NOGROUND,0,0};
                        o->Message(&msg);
                    }
                    //   , ,   
                } else if( isGroundTile(o->x+2,o->y+16) || isGroundTile(o->x+12, o->y+16) ) {
                        Game_Message msg={GM_GROUND,0,0};
                        o->Message(&msg);
                    }

                break;
//            case :
//                break;
//            default:
        }
	}
}



void Game_Object::Create(LEVFILEOBJECT *levobj)
{
    x=levobj->posx;
    y=levobj->posy;
}


/*==========================================================

        ***   PLAYER    ***
*/
GO_Player::GO_Player()
{
    bCanClimbUp=false;
    bCanClimbDown=false;
    type=GO_PLAYER;
    Frames.AddFrames( &gfxArt, 0,48,  16,16,  3,2 );
}


//    Move    .
//     -   
//  ,   ..    Message
//     .
void GO_Player::Move(double td)
{
static frame1,frame2;  //    
static float fd=0;     //      

        //  
        if( NdxInput->Keys[DIK_LEFT] && !NdxInput->Keys[DIK_RIGHT])  {
            div_x=(action==SA_FALL)? -10:-70;
            if( action==SA_CLIMB ) div_y=0;
            frame1=4;
            frame2=5;
        } else
        //  
        if( NdxInput->Keys[DIK_RIGHT] && !NdxInput->Keys[DIK_LEFT])  {
            div_x=(action==SA_FALL)? 10: 70;
            if( action==SA_CLIMB ) div_y=0;
            frame1=1;
            frame2=2;
        }
        else if( !NdxInput->Keys[DIK_UP]&& !NdxInput->Keys[DIK_DOWN] ){
        //       
            if(action!=SA_FALL) {
                frame1=0;
                frame2=0;
                div_x=div_y=0;
            } else div_x=0;
        }
//    } //  if( action!=SA_FALL)



    //        
    if( NdxInput->Keys[DIK_UP])  {
        if( bCanClimbUp )  {
            if(action!=SA_CLIMB) div_x=0;
            action=SA_CLIMB; //      ,   
            div_y=-40;
            frame1=1;
            frame2=3;
        } else {
            if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
        }
    } else

    //       ,   
    if( NdxInput->Keys[DIK_DOWN] )  {
        if( bCanClimbDown )  {
            if(action!=SA_CLIMB) div_x=0;
            action=SA_CLIMB; //      ,   
            div_y=40;
            frame1=1;
            frame2=3;
        } else if( action==SA_CLIMB )  {  //    ,  
                action=SA_STILL;
                div_y=0;
                frame1=0;
                frame2=0;
            }
    }


//   
    if( frame == frame1 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame2;
            fd=0;
        }
    } else
    if( frame == frame2 ) {
        fd+=td;
        if( fd > 0.04 ) {
            frame=frame1;
            fd=0;
        }
    } else {
        frame=frame1;
        fd=0;
    }




    //  
    if( action==SA_FALL) {
            frame=3;
    }

    prev_x = x;
    prev_y = y;

    x = x + div_x*td;
    y = y + div_y*td;

if( NdxInput->Keys[DIK_K])
OutMessage("Player x="+FloatToStr(x)+" y="+FloatToStr(y));



}

void GO_Player::Message(void *m)
{
    Game_Message *msg=(Game_Message *)m;
    switch (msg->type)
    {
      case GM_INTOGROUND_X:  //        
        OutMessage("Player Message: GM_INTOGROUND_X");
        x=prev_x;
      break;
      case GM_INTOGROUND:  //     
        OutMessage("Player Message: GM_INTOGROUND");
        x=prev_x;
        y=prev_y;
        frame=0;
        action=SA_STILL;
      break;

      case GM_NOGROUND:  //  
        OutMessage("Player Message: GM_NOGROUND");
        action=SA_FALL;
        div_x=0;
        div_y=70;
      break;

      case GM_GROUND:  //  
        OutMessage("Player Message: GM_GROUND");
        action=SA_STILL;
        div_x=0;
        div_y=0;
        frame=0;
      break;
    }
}

void GO_Player::CheckForHits(NDX_SpriteControl *Sprites)
{
    Game_Object *o;
    // ,       
    //          
	for(int n=0;n<Sprites->NumSprites;n++)
	{
        o=(Game_Object*)Sprites->Sprites[n];
        switch( o->type )
        {
            case GO_LEVEL:
                //    
                if( ((GO_Level*)o)->Level.GetTile(x+2,y+15) ==2 &&
                      ((GO_Level*)o)->Level.GetTile(x+12,y+15) ==2 )  {
                //     ,  
                    bCanClimbUp=true;
                } else bCanClimbUp=false;
                //     
                if(   ((GO_Level*)o)->Level.GetTile(x+2,y+16) ==2  &&
                      ((GO_Level*)o)->Level.GetTile(x+12,y+16) ==2  ) {
                //    (   )  ,  
                    bCanClimbDown=true;
                } else bCanClimbDown=false;

                break;
//            case :
//                break;
            default: ;
        }
	}
}







/*==========================================================

        ***   ENEMY1    ***
*/
GO_Enemy1::GO_Enemy1()
{
    type=GO_ENEMY1;
    Frames.AddFrames( &gfxArt, 0,80,  16,16,  3,1 );
}

void GO_Enemy1::Move(double td)
{
static int move_count=0;
    if(div_x == 0 ) div_x=40;

    //   frame
    frame+=td*30;
    if( frame > 2) frame=0;

    // 
    x+=div_x*td;

    move_count+=td*30;

    if (move_count > 30)
    {
        div_x *= (-1);
        move_count=0;
    }


}



//---------------------------------------------------------------------------

#pragma package(smart_init)
