//---------------------------------------------------------------------------

#ifndef ObjectsH
#define ObjectsH

#include "CLevel.h"

//  
#define GO_PLAYER 1      // 
#define GO_ENEMY1 2      // 1
#define GO_KEY    66     // 
#define GO_LEVEL  100    //  

// Sprite Actions -  
#define SA_STILL 100   // 
#define SA_WALK  101   // 
#define SA_FALL  102   // 
#define SA_CLIMB 103   //   


//     
class Game_Object;
#define GM_DIE 10  //        
#define GM_FALL 20  //    ,          .
#define GM_GROUND 30  //  ,         
#define GM_INTOGROUND 40  //      
#define GM_NOGROUND  50  // ,       
#define GM_INTOGROUND_X 60  //       
                            // (    ,   ,    )
//#define GM_

struct Game_Message
{
int type;
int param;
Game_Object *Sender;
};


//    NDX_Sprites   Game_Control
//      
class Game_Control : public NDX_SpriteControl
{
public:
    void Analize();  //   
    void GameInit();            //  
    void InitLevel(int num);    //  
    void DrawGameBar();         //  , , ...
    void RefreshGameBar();      //   , , ...
    void PlayerKilled();        //   Player::CheckForHits,    
    void GameOver();            //   PlayerKilled(),   
    void NextLevel();           //     
    void RemoveAll();           //   

    float showDelay; //   ,       
    int bGameOver;
    int need_keys; //      
    int keys;  //   

private:
    NDX_Surface GameBarSurf;  //    ,...
    int Level;  //  
    int Lives;  //   
    int Score;  //   

};



//  -  
class Game_Object : public NDX_Sprite
{
public:
    float x,y;
    float frame;  //   
    int prev_x, prev_y;  //  
    float div_x,div_y;   //     
    int action;  //     
    NDX_FrameList Frames;  //    
    int type;   //  
    int len,hgt;  //    
    void Draw();
    Game_Object();
    virtual void Create(LEVFILEOBJECT *levobj);
    virtual void CheckForHits( NDX_SpriteControl *Sprites ){};
    BOOL HitObject( Game_Object* obj);
};

//  - 
class GO_Level : public Game_Object
{
public:
    CLevel Level;
    void Draw();
  __fastcall GO_Level(char *name);
    void CheckForHits(NDX_SpriteControl *Sprites);
    int isPassingTile(int pixel_x,int pixel_y);
    int isGroundTile(int pixel_x,int pixel_y);
};

class GO_Player : public Game_Object
{
public:
    GO_Player();
    void Move(double);
    void CheckForHits(NDX_SpriteControl *Sprites);
    void Message(void *msg);
private:
    int snd_Walk_h,snd_Fall_h;  // Handle  
    BOOL bCanClimbUp;  //      
    BOOL bCanClimbDown;  //      
};

class GO_Enemy1 : public Game_Object
{
public:
    GO_Enemy1();
    void Move(double);
    void Message(void *msg);
private:
    float move_count;
};


// 
class GO_Key : public Game_Object
{
public:
    GO_Key();
//    void Move(double);
//    void Message(void *msg);
private:
//    float move_count;
};

//---------------------------------------------------------------------------
#endif
