//---------------------------------------------------------------------------

#include <vcl.h>

#define NDX_INC_LIBS
#include <NukeDX.h>

#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Objects.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//   NukeDX
NDX_Screen *NdxScreen;  //   
NDX_Input       *NdxInput = NULL;  //   NDX_Input
NDX_Surface gfxArt; //   
NDX_Timer GameTimer;

BOOL bAppInit=0;  //    
BOOL bRunApp=0;   //  ,   

void UpdateFrame();  //    
void DrawFrame(double td);    //    Back 

void GameInit();            //  
void InitLevel(int num);    //  

//    (  Program_State )
#define PS_NONE 0
#define PS_SHOW_LEVELNUMBER 1
#define PS_SHOW_GAMEOVER 2
#define PS_SHOW_VICTORY 3
#define PS_ACTIVE 10

//      
int Program_State=PS_NONE;


//   
Game_Control  Game_Sprites;


int Level;  //  
int Lives;  //   
int Score;  //   


BOOL  bTesting;  //   



const DIDATAFORMAT c_dfDIJoystick={0,0,0,0,0,0};


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{
    //  NukeDX   
    if( !bAppInit)  {
	//    NDX_Screen
        NdxScreen = new NDX_Screen;
	// 
        NdxScreen->Create();
	//    320240
        NdxScreen->SetWindowed(0,Handle,320,240);

    //  NDX_Input
        NdxInput = new NDX_Input;
        NdxInput ->SetActiveDevices(0 /* mouse */ ,1 /* keyboard */,0 /* joystic */);
        NdxInput ->Create ( MainInstance, Handle );

	//    
        gfxArt.LoadBMP(NdxScreen,NDXST_BESTFIT,"art.bmp",false);
        gfxArt.SetColorKey(0);  //       
        gfxArt.SetTransP(true);

	//   ,   
        bAppInit=true;
    }
    //    START.
    New1->Enabled=false;

    GameInit();

	//   ,   
        bRunApp=true;

        GameTimer.StartNow();
	//    ,   
        do
        {
        //   
            UpdateFrame();

	    //    Windows
            Application->ProcessMessages();

        //     
//            Sleep(1);
        }
        while(bRunApp == true);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    delete NdxScreen;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_ESCAPE)  {
	bRunApp = false;
	Close();
    }
    if(Key == VK_RETURN)  {
        New1Click(Sender);
    }

    if(Key == VK_NUMPAD1)  {
        if( NdxInput )
            NdxInput->ReAcquire();
    }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
    Form2->ShowModal();
}
//---------------------------------------------------------------------------
void UpdateFrame()
{
double td;

    td = GameTimer.GetDelta(1);  //   

	//  Back 
	NdxScreen->Back->Clear(0);

    //  
    NdxInput->Refresh();

	//    Back 
	DrawFrame(td);

    NdxScreen->ShowFPS(0,0);

	//  Back  Front 
	NdxScreen->Flip();
}

void DrawFrame(double td)
{
    switch (Program_State)
    {
      case PS_SHOW_LEVELNUMBER: ;
      break;
      case PS_SHOW_GAMEOVER: ;
      break;
      case PS_SHOW_VICTORY: ;
      break;
      case PS_ACTIVE:
        Game_Sprites.MoveAll(td);
        Game_Sprites.Analize();
        Game_Sprites.DrawAll();
      break;
    }

}

//---------------------------------------------------------------------------
void GameInit()
{
//   
    Level=1;
    Lives=3;
    Score=0;

    InitLevel(1);
}
//---------------------------------------------------------------------------
void InitLevel(int num)
{
   char buf[200];
   BOOL bPlayerLoaded=false;
   int type;
   Game_Object *p;

   GO_Level *lev;

    //    
//    Game_Sprites.RemoveAll();


    //    
    if( !bTesting )  {
        sprintf(buf,"level%d.lev",num);
        lev =  new GO_Level(buf);
    }
    else  {
        lev =  new GO_Level( ParamStr(1).c_str() );
    }


    Game_Sprites.AddSprite(lev);  //     

    //    
     for(int n=0; n<lev->Level.KolObj; n++)
    {
		p=NULL;
		type=lev->Level.Obj[n].type;
        switch(type)	//   
        {
        case GO_ENEMY1:
            p=new GO_Enemy1();
            break;
        case GO_PLAYER:
            if(bPlayerLoaded)continue;
            p=new GO_Player();
//            Player=p;   //    
            bPlayerLoaded=true;
            break;
        };
		if(p)	//  
		{
			p->Create( &lev->Level.Obj[n] ); // 
	        Game_Sprites.AddSprite(p);		//    
		}
    }

//     ,    
	 if( !bPlayerLoaded )
        {
            MessageBox( Application->Handle, "Object Player not found in this level", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }

    Program_State=PS_ACTIVE;


}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        bRunApp=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label4Click(TObject *Sender)
{
    New1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
        bRunApp=false;
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label6Click(TObject *Sender)
{
    Exit1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //    :
    //    (  )
    if( ParamStr(1) != "" /* &&    */ )
    {
        bTesting=true;
    }
    else
        bTesting=false;

}
//---------------------------------------------------------------------------





