//---------------------------------------------------------------------------

#include <vcl.h>

#define NDX_INC_LIBS
#include <NukeDX.h>

#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Objects.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//   NukeDX
NDX_Screen *NdxScreen;  //   
NDX_Input  *NdxInput = NULL;  //   NDX_Input
NDX_Surface gfxArt; //   
NDX_Timer GameTimer;

NDX_Sound *GameSound;  //    NDX_Sound
NDX_Sample *SampleWalk;
NDX_Sample *SampleMy;
NDX_Sample *SampleDie;
NDX_Sample *SampleGameOver;
NDX_Sample *SampleFall;


BOOL bAppInit=0;  //    
BOOL bRunApp=0;   //  ,   

void UpdateFrame();  //    
void DrawFrame(double td);    //    Back 

//      
int Program_State=PS_NONE;


// ,    
Game_Control  GameControl;

BOOL  bTesting;  //   


const DIDATAFORMAT c_dfDIJoystick={0,0,0,0,0,0};
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{
NDXERR nerr;

    //  NukeDX   
    if( !bAppInit)  {
	//    NDX_Screen
        NdxScreen = new NDX_Screen;
	// 
        NdxScreen->Create();
	//    320240
        NdxScreen->SetWindowed(0,Handle,320,240);

    //  NDX_Input
        NdxInput = new NDX_Input;
        NdxInput ->SetActiveDevices(0 /* mouse */ ,1 /* keyboard */,0 /* joystic */);
        NdxInput ->Create ( MainInstance, Handle );

	//    
        nerr=gfxArt.LoadBMP(NdxScreen,NDXST_BESTFIT,"art.bmp",false);
        if( nerr ) {  MessageBox(Handle,"   art.bmp","Fatal Error",MB_OK); return; }
        gfxArt.SetColorKey(0);  //       
        gfxArt.SetTransP(true);

    //   NDX_Sound
        GameSound=new NDX_Sound;
        GameSound->Create(Handle);

    //  
        SampleWalk=new NDX_Sample;
        SampleMy=new NDX_Sample;
        SampleDie=new NDX_Sample;
        SampleGameOver=new NDX_Sample;
        SampleFall=new NDX_Sample;
        SampleWalk->LoadWAV(GameSound, "sound1.wav",1);
        SampleMy->LoadWAV(GameSound, "sound2.wav",1);
        SampleDie->LoadWAV(GameSound, "sound3.wav",1);
        SampleGameOver->LoadWAV(GameSound, "sound4.wav",1);
        SampleFall->LoadWAV(GameSound, "sound5.wav",1);


	//   ,   
        bAppInit=true;
    }
    //    START.
    New1->Enabled=false;

    GameControl.GameInit();

	//   ,   
        bRunApp=true;

        GameTimer.StartNow();
	//    ,   
        do
        {
        //   
            UpdateFrame();

	    //    Windows
            Application->ProcessMessages();

        //     
            Sleep(10);
        }
        while(bRunApp == true);

    //  
    FormPaint(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    delete GameSound;
    delete NdxScreen;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_ESCAPE)  {
	bRunApp = false;
	Close();
    }
    if(Key == VK_RETURN)  {
        New1Click(Sender);
    }

    if(Key == VK_NUMPAD1)  {
        if( NdxInput )
            NdxInput->ReAcquire();
    }


}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
    Form2->ShowModal();
}
//---------------------------------------------------------------------------
void UpdateFrame()
{
double td;

    td = GameTimer.GetDelta(1);  //   

    if(  GameControl.bGameOver ) {
        bRunApp=false;
        return;
    }




//   ,  
    if( !GameControl.showDelay )  {
    	//  Back 
	    NdxScreen->Back->Clear(0);

        //  
        NdxInput->Refresh();

        //    Back 
        DrawFrame(td);
        if( GameControl.showDelay ) return;

        NdxScreen->ShowFPS(0,0);

        //  Back  Front 
        NdxScreen->Flip();
    }
    else {  //     
        GameControl.showDelay-=td*1000;
        if( GameControl.showDelay < 0 ) GameControl.showDelay=0;
    }

}

void DrawFrame(double td)
{
    switch (Program_State)
    {
      case PS_SHOW_LEVELNUMBER: ;
      break;
      case PS_SHOW_GAMEOVER: ;
      break;
      case PS_SHOW_VICTORY: ;
      break;
      case PS_ACTIVE:
        GameControl.MoveAll(td);
        GameControl.Analize();
        GameControl.DrawAll();
        GameControl.DrawGameBar();
      break;
    }

}

//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        bRunApp=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label4Click(TObject *Sender)
{
    New1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
        bRunApp=false;
        Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Label6Click(TObject *Sender)
{
    Exit1Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //    :
    //    (  )
    if( ParamStr(1) != "" /* &&    */ )
    {
        bTesting=true;
    }
    else
        bTesting=false;

}
//---------------------------------------------------------------------------





void __fastcall TForm1::FormPaint(TObject *Sender)
{
//    Label1->
}
//---------------------------------------------------------------------------

