//---------------------------------------------------------------------------
#include <vcl.h>
#include <NukeDX.h>
#pragma hdrstop

#include "Unit1.h"
#include "Game.h"
#include "Objects.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

// ***    ***
// 
extern NDX_Screen  *NdxScreen;  //   
extern NDX_Surface *gameArt; //   
// 
extern NDX_Sound   *NdxSound;  //    NDX_Sound
extern NDX_Sample  *sampleWalk;
extern NDX_Sample  *sampleMy;
extern NDX_Sample  *sampleDie;
extern NDX_Sample  *sampleOver;
extern NDX_Sample  *sampleFall;
extern NDX_Sample  *sampleComp; // sound "Level Complete"
// 
extern NDX_Timer   *NdxTimer;
extern NDX_Input   *NdxInput;  //   NDX_Input

extern GO_Level *level;     //    
extern GO_Player *player;   //    

int Level;  //  
int Lives;  //   
int Score;  //   

double GameOverDelay;       //   .  GAMEOVER
double ShowLevelDelay;      //    
double PlayerDelay;         //   ,      

extern BOOL bTesting;   //    (   Level Editor)
extern int Prog_State;

extern BOOL Menu_Init();
extern BOOL TheEnd_Init();


/*     Game_Control,    ,
          
*/
Game_Control *GameControl=NULL;

extern NDX_SpriteControl *Sprites;


BOOL Game_Init()
{
    if( GameControl ) delete GameControl;
    GameControl = new Game_Control;
    Sprites = GameControl;
    GameControl -> GameInit();

    //   
    GameOverDelay=0;
    ShowLevelDelay=0;
    PlayerDelay=0;

//   
    Level=1;
    Lives=3;
    Score=0;

    if( !GameControl -> InitLevel(1) )
    {
        ShowMessage("Level initialisation failed, exiting.");
        Form1->Close();
    }

    ShowLevelDelay=1;
    Prog_State=PS_GAME;

    return true;
}

void Game_Update(double td)
{
    if( GameOverDelay )
    {
        GameOverDelay-=td;
        if( GameOverDelay < 0 )
            Menu_Init();
    }
    else if( ShowLevelDelay )
    {
        ShowLevelDelay-=td;
        if( ShowLevelDelay < 0 ) ShowLevelDelay=0;
    }
    else if( PlayerDelay )
    {
   //       
        PlayerDelay-=td;

        //     
        GameControl->MoveAll(td);

        //   
        if( PlayerDelay < 0 )
        {
            PlayerDelay=0;

            //      
            //       ,
            //     "Game Over"
            if( Lives < 0 ) {
                GameOverDelay=3.5;
                sampleOver->Play(0,0);
            }
            else
            {
                //    , 
                //   
                ShowLevelDelay=1;
                if( Level < 20 )
                {
                    if( !GameControl -> InitLevel(Level) )
                    {
                        ShowMessage("Level initialisation failed, exiting.");
                        Form1->Close();
                    }
                }
                else
                    //    20 ,  
                    TheEnd_Init();
                }
        }
    } // end if( PlayerDelay )
    else
    {
        //     ,
        // ,    
        GameControl->MoveAll(td);
        GameControl->Analize();
    }
}

void Game_Draw()
{
    //     
    GameControl->DrawAll();
    GameControl->DrawGameBar();

    //        
    //       Game Over
    if( GameOverDelay )
        NdxScreen->Back->FormattedText(100,100,RGB(255,255,255),NULL,"G A M E  O V E R");

    //         ,
    //       
    if( ShowLevelDelay )
        NdxScreen->Back->FormattedText(100,100,RGB(255,255,255),NULL,"LEVEL %d", Level);

}





/*   Game_Control

     Game_Control   NDX_SpriteControl
          ,  
         .
*/
void Game_Control::GameInit()
{
//  
    GameBarSurf.Create(NdxScreen,NDXST_SYSMEM,236,16);
}
//---------------------------------------------------------------------------
BOOL Game_Control::InitLevel(int num)
{
    int type;
    Game_Object *p;

    //      
    RemoveAll();

    //    
    player = NULL;
    level = NULL;

    //   
    keys=0;         //   
    need_keys=0;    //    (    GO_KEY)

    //    
    //       
    //    
    if( !bTesting )
    {
        char buf[256];
        //        
        sprintf(buf,"levels\\level%d.lev",num);
        //  ,   ,   
        level =  new GO_Level(buf);
    }
    else
        level =  new GO_Level( ParamStr(1).c_str());

    //     
    if( !level->Level.bLoaded )
    {
        ShowMessage("Level file "+ParamStr(1)+" not loaded!");
        return false;
    }

    //      
    AddSprite(level);

    //     
    for(int n=0; n<level->Level.KolObj; n++)
    {
		p=NULL;
		type=level->Level.Obj[n].type;
        switch(type)	//   
        {
        case GO_ENEMY1:
            p=new GO_Enemy1();
            break;
        case GO_KEY:
            p=new GO_Key();
            need_keys++;
            break;
        case GO_KAPLYA_EMITER:
            p=new GO_Kaplya_Emiter();
            break;
        case GO_LIFT:
            p=new GO_Lift();
            break;
        case GO_LIFT_TARGET:
            p=new GO_Lift_Target();
            break;
        case GO_PLAYER:
            //    ,     :)
            if( player ) continue;
            player = new GO_Player();
            p = player;
            break;
        }

        //        
        //   
		if(p)
		{
            //     
            //        
			p->Create( &level->Level.Obj[n] );
            //     
	        AddSprite(p);
		}
    }

//     
	 if( !player )
        {
            MessageBox( Application->Handle, "Object Player not found in this level", "Level error", MB_OK );
            return false;
        }

    //     
	 if( !need_keys )
        {
            MessageBox( Application->Handle, "Not found keys in this level.", "Level error", MB_OK );
            return false;
        }

    RefreshGameBar();  //    

    return true;
}
//---------------------------------------------------------------------------
void Game_Control::PlayerKilled()
{
    sampleDie->Play(0,0);
    Lives--;
    PlayerDelay=2.5;
}
//-----------------------------------------------------------------------------
void Game_Control::NextLevel()
{
    ++Level;
    PlayerDelay=3;
    sampleComp->Play(0,0);
}
//-----------------------------------------------------------------------------
void Game_Control::Analize()
{
    //    (   ..)
	for(int n=0;n<NumSprites;n++)
	{
        //      CheckForHits
        //         
		((Game_Object*)Sprites[n])->CheckForHits();
	}
}
//-----------------------------------------------------------------------------
void Game_Control::RefreshGameBar()
{
    //      
    GameBarSurf.Clear(0);
    GameBarSurf.FormattedText(0,0,RGB(255,255,255),NULL,"score:%d   level:%d  lives:%d  keys:%d/%d",Score,Level,Lives,keys,need_keys);
}
//-----------------------------------------------------------------------------
void Game_Control::DrawGameBar()
{
    //  
    GameBarSurf.Draw(NdxScreen->Back,80,0);
}
//---------------------------------------------------------------------------
void Game_Control::RemoveAll()
{
    NDX_Sprite *p;

    //   ,        
    while( NumSprites )
    {
        //    
        p = Sprites[0];
        GameControl->RemoveSprite(p);   //   
        delete p;                       //  
    }
}
//-----------------------------------------------------------------------------

