//---------------------------------------------------------------------------
#include <vcl.h>
#include <NukeDX.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Menu.h"
//---------------------------------------------------------------------------


// ***    ***
// 
extern NDX_Screen  *NdxScreen;
extern NDX_Surface *menuArt;
// 
extern NDX_Sound   *NdxSound;
// 
extern NDX_Timer   *NdxTimer;
extern NDX_Input   *NdxInput;

extern int Prog_State;
extern BOOL bRunApp;
extern BOOL Game_Init();

//     - 
NDX_SpriteControl *MenuSprites=NULL;

extern int m_x,m_y;    //  
int m_b;  //   
int n;  //   

BOOL isPoint_in_RECT(int x, int y,RECT area);

//   
void action_start();
void action_exit();
void action_about();


//  ***   ***

BOOL Menu_Init()
{
    //  
    if( MenuSprites )
    {
        for( n=0; n<MenuSprites->NumSprites; n++)
        {
            delete MenuSprites->Sprites[n];
            MenuSprites->RemoveSprite(MenuSprites->Sprites[n]);
        }
    }
    else
        MenuSprites=new NDX_SpriteControl;


    Menu_Option *option1= new Menu_Option;
    Menu_Option *option2= new Menu_Option;
    Menu_Option *option3= new Menu_Option;

    option1 -> Create( Rect(120,100,120+76,100+28), Rect(0,5,76+0,28+5),action_start);
    option2 -> Create( Rect(120,140,120+74,140+28),Rect(0,41,74+0,28+41),action_exit);
    option3 -> Create( Rect(120,180,120+76,180+27),Rect(0,74,76+0,27+74),action_about);


//   
    MenuSprites->AddSprite(option1);
    MenuSprites->AddSprite(option2);
    MenuSprites->AddSprite(option3);

    MenuSprites->AddSprite(new Menu_Header);

//    ,    
    MenuSprites->AddSprite(new Menu_Cursor);

//    NdxInput->SetMouseLimit(NdxScreen);
//    NdxInput->SetMouseAbs();
//    NdxInput->SetMousePos(100,100);
//    m_x=NdxInput->MouseXPos;
//    m_y=NdxInput->MouseYPos;
    m_b=0;

    Prog_State = PS_MENU;
    return true;
}

BOOL Menu_Update(double td)
{
/*   DirectInput    , 
       Windows.  
       ,     .
     - ,   , , 

    m_x = NdxInput -> MouseXPos;
    m_y = NdxInput -> MouseYPos;

*/
    m_b = NdxInput -> MouseLB;

    MenuSprites->MoveAll(td);

    if( NdxInput->Keys[DIK_RETURN] )
        action_start();

    return true;
}


void Menu_Draw()
{
    MenuSprites->DrawAll();
}


void Menu_Cursor::Draw()
{
    //      
    RECT area=(!m_b)? Rect(0,120,7,15+120) : Rect(8,120,8+8,15+120);
    menuArt -> Draw(NdxScreen->Back,m_x,m_y,area);
}
/*
//    -  
void Menu_Cursor::Update(double td)
{
}
*/

void Menu_Header::Draw()
{
    //      
    RECT area=Rect(0,220,243,220+34);
    menuArt -> Draw(NdxScreen->Back,40,30,area);
}



//  ***     ***

void Menu_Option::Create(RECT _area, RECT _src, void(*_action)() )
{
    //      
    memcpy(&area,&_area,sizeof(RECT));
    memcpy(&src,&_src,sizeof(RECT));
    action=_action;

    bSelected=false;
}

void Menu_Option::Move(double/* td */)
{
    if( bSelected)
    {
        if( !isPoint_in_RECT(m_x,m_y,area) )
            bSelected=false;
    }
    else
    {
        if( isPoint_in_RECT(m_x,m_y,area) )
        {
            bSelected=true;
// OnMouseOver sound
//            sampleSelect->Play(0,0);
        }
    }

    //     ,  
    if( bSelected && NdxInput->MouseLBClick )
    {
        NdxInput->MouseLBClick=false;
        action();
    }
}

void Menu_Option::Draw()
{
    menuArt->Draw(NdxScreen->Back,src,area);

    //      ,   -  (    )
/*    if( bSelected ) ; */
//    menuArt->Draw(NdxScreen->Back,area.left, area.top,Rect(0,75,80,30+75));
//    menuArt->DrawAlpha(NdxScreen->Back,area.left,area.top,Rect(1,75,80+1,75+30));
}


BOOL isPoint_in_RECT(int x, int y,RECT area)
{
    //    ,  true
    if( x<area.left) return false;
    if( x>area.right) return false;
    if( y<area.top) return false;
    if( y>area.bottom) return false;
    return true;
}

void action_start()
{
    Game_Init();
}

void action_exit()
{
    bRunApp=false;
}

void action_about()
{
    Form2->ShowModal();
}

