//---------------------------------------------------------------------------

#ifndef ObjectsH
#define ObjectsH

#include "CLevel.h"

//  
#define GO_PLAYER 1      // 
#define GO_ENEMY1 2      // 1
#define GO_KAPLYA_EMITER  10  //  
#define GO_KAPLYA 11        //  
#define GO_LIFT   12        // 
#define GO_LIFT_TARGET   13 //   
#define GO_KEY    66     // 
#define GO_LEVEL  100    //  

// Sprite Actions -  
#define SA_STILL 100   // 
#define SA_WALK  101   // 
#define SA_FALL  102   // 
#define SA_CLIMB 103   //   


//     
class Game_Object;

// typedef enum {
#define GM_DIE 10  //        
#define GM_FALL 20  //    ,          .
#define GM_GROUND 30  //  ,         
#define GM_INTOGROUND 40  //      
#define GM_NOGROUND  50  // ,       
#define GM_INTOGROUND_X 60  //       
                            // (    ,   ,    )
#define GM_LIFTMOVE     70  //     
#define GM_CANTMOVE     80  //  ,        
// } gamemessage_t;


//#define GM_
struct Game_Message
{
int type;
int param;
Game_Object *sender;
};


//  -  
class Game_Object : public NDX_Sprite
{
public:
    Game_Object();  // 
    virtual void Create(LEVFILEOBJECT *levobj);
    virtual void CheckForHits(){};
    BOOL HitObject( Game_Object* obj);
    BOOL is_IntoGround();
    BOOL is_IntoGround(int _x,int _y);
    BOOL is_NoGround();
    void Draw();

    float x,y;          //  
//    int prev_x, prev_y;  //  
    int param;
    float frame;  //   
    float div_x,div_y;   //     
    int action;  //     
    NDX_FrameList Frames;  //    
    int type;   //  
    int len,hgt;  //    
};

//  - 
class GO_Level : public Game_Object
{
public:
    CLevel Level;
    void Draw();
    GO_Level(char *name);
//    void CheckForHits();
    BOOL isPassingTile(int pixel_x,int pixel_y);
    BOOL isGroundTile(int pixel_x,int pixel_y);
};

class GO_Lift;

class GO_Player : public Game_Object
{
public:
    GO_Player();
    void Move(double);
    void CheckForHits();
    void Message(void *msg);
    BOOL bLiftUse;  // true    
    GO_Lift *lift;  //   ,     (NULL  )
private:
    int frame1,frame2;  //    
    float fd;     //      
    float prev_x, prev_y;
    int snd_Walk_h,snd_Fall_h;  // Handle  
    BOOL bCanClimbUp;  //      
    BOOL bCanClimbDown;  //      
};

class GO_Enemy1 : public Game_Object
{
public:
    GO_Enemy1();
    void Move(double);
    void Message(void *msg);
    void CheckForHits();
private:
    float move_count;
};


// 
class GO_Key : public Game_Object
{
public:
    GO_Key();
    void CheckForHits();
//    void Move(double);
//    void Message(void *msg);
private:
//    float move_count;
};

// _
class GO_Kaplya_Emiter : public Game_Object
{
public:
    GO_Kaplya_Emiter();
    void Move(double);
private:
    float delay;
};

//  
class GO_Kaplya : public Game_Object
{
public:
    GO_Kaplya(GO_Kaplya_Emiter *emiter);
    void Move(double);
    void Message(void *msg);
    void CheckForHits();
};

// 
class GO_Lift : public Game_Object
{
public:
    GO_Lift();
    void Move(double);
    void CheckForHits();
    void Message(void *m);
    float prev_x, prev_y; //     

private:
    void Search_Target(); //   ( ,       )
    float delay;  //    
    float target_x, target_y;  // 
    float begin_x, begin_y; // 
    float cosk,sink;    //     
    float track_len;    //  
    float lin_pos;      //     (   0...track_len )
    float prev_lin_pos; //    
};

//   
class GO_Lift_Target : public Game_Object
{
public:
    GO_Lift_Target::GO_Lift_Target();
};

//---------------------------------------------------------------------------
#endif
