//---------------------------------------------------------------------------
#include <vcl.h>
#define NDX_INC_LIBS
#include <NukeDX.h>
#pragma hdrstop

#pragma package(smart_init)

#include "Unit1.h"
#include "Unit2.h"
#include "Game.h"
#include "Menu.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"

TForm1 *Form1;


// ***  Direct_X (  NukeDX ) ***

// 
NDX_Screen  *NdxScreen;  //   
NDX_Surface *gameArt; //   
NDX_Surface *menuArt; //   

// 
NDX_Sound   *NdxSound;  //    NDX_Sound
NDX_Sample  *sampleWalk;
NDX_Sample  *sampleMy;
NDX_Sample  *sampleDie;
NDX_Sample  *sampleOver;
NDX_Sample  *sampleFall;
NDX_Sample  *sampleComp;
NDX_Sample  *sampleWin;

// 
NDX_Timer   *NdxTimer;
NDX_Input   *NdxInput;  //   NDX_Input



//  ***    ***

BOOL bAppInit=0;  //    
BOOL bRunApp=0;   //  ,   

int Prog_State=NULL; //   
int m_x,m_y;    //  
BOOL  bTesting=false;  //   


//  ***   ***

void UpdateFrame();
BOOL App_Init(HWND Handle);


    /*    dinput.lib  Borland
         c_dfDIJoystick,  
           
       (      , , )
    */
    const DIDATAFORMAT c_dfDIJoystick={0,0,0,0,0,0};

#define RETURN_FALSE_IF_NDXERROR(x)              \
    if( (err=x) != NDXERR_OK )                  \
    {                                           \
        MessageBox(Handle,NDX_ErrorToStr(err),"NDX error",MB_OK);       \
        return false;                           \
    }


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    //       NukeDX
    delete NdxScreen;
    delete NdxSound;
    delete NdxInput;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_ESCAPE)  {
    	bRunApp = false;
    }

    if(Key == VK_NUMPAD1)  {
        if( NdxInput )
            NdxInput->ReAcquire();
    }
}

//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        bRunApp=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    //    :
    //    (  )
    if( ParamStr(1) != "" /* &&    */ )
        bTesting=true;

}
//---------------------------------------------------------------------------
BOOL App_Init(HWND Handle)
{
    NDXERR err;

// 
    NdxScreen = new NDX_Screen;
    RETURN_FALSE_IF_NDXERROR(NdxScreen->Create())
    RETURN_FALSE_IF_NDXERROR(NdxScreen->SetWindowed(0,Handle,320,240))

    gameArt = new NDX_Surface;
    RETURN_FALSE_IF_NDXERROR(gameArt -> LoadBMP(NdxScreen,NDXST_BESTFIT,"pics\\art.bmp",false))
    menuArt = new NDX_Surface;
    RETURN_FALSE_IF_NDXERROR(menuArt -> LoadBMP(NdxScreen,NDXST_BESTFIT,"pics\\menu.bmp",false))
// 
    NdxSound = new NDX_Sound;
    NdxSound -> Create(Handle);

    sampleWalk = new NDX_Sample;
    sampleWalk -> LoadWAV(NdxSound,"sounds\\sound1.wav",1);
    sampleMy   = new NDX_Sample;
    sampleMy   -> LoadWAV(NdxSound,"sounds\\sound2.wav",3);
    sampleDie  = new NDX_Sample;
    sampleDie  -> LoadWAV(NdxSound,"sounds\\sound3.wav",1);
    sampleOver = new NDX_Sample;
    sampleOver -> LoadWAV(NdxSound,"sounds\\sound4.wav",1);
    sampleFall = new NDX_Sample;
    sampleFall -> LoadWAV(NdxSound,"sounds\\empty.wav",1);  // sound5
    sampleComp = new NDX_Sample;
    sampleComp -> LoadWAV(NdxSound,"sounds\\sound6.wav",1);
    sampleWin = new NDX_Sample;
    sampleWin -> LoadWAV(NdxSound,"sounds\\win.wav",1);
// 
    NdxTimer = new NDX_Timer;
    NdxInput = new NDX_Input;
    NdxInput ->SetActiveDevices(1 /* mouse */ ,1 /* keyboard */,0 /* joystic */);
    NdxInput -> Create (MainInstance,Handle);

    return true;
}
//---------------------------------------------------------------------------
void UpdateFrame()
{
    double td = NdxTimer -> GetDelta(1);  //   
    NdxScreen->Back->Clear(0);  //  
    NdxInput->Refresh();        //   

    switch (Prog_State)
    {
      case PS_MENU:
        Menu_Update(td);
        Menu_Draw();
      break;
      case PS_GAME:
        Game_Update(td);
        Game_Draw();
      break;
      default:      //    Prog_State=0,     .   Prog_State   
        //        ( )
        //    ,   
        if( bTesting )
            Game_Init();
        else
            Menu_Init();
    }

//    NdxScreen->ShowFPS(0,0);
    NdxScreen->Flip();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
    /*       , Windows
            ,  
             DirectX
            
    */
    if( !bAppInit )
    {
        if( App_Init(Handle) )
            bAppInit=true;
        else
        {
            MessageBox(Handle,"Error init application","Error",MB_OK);
            Close();
            return;
        }

        Cursor=crNone;

        //  
        bRunApp = true;

        NdxTimer->StartNow();

        do //    ,   
        {
            UpdateFrame();  //   
            Application->ProcessMessages();  //    Windows
            Sleep(8);  // ,      
        }
        while(bRunApp == true);
    }
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    /*   DirectInput       
           ,  
         Windows
    */
    m_x=X;  m_y=Y;
}
//---------------------------------------------------------------------------


